import React, { Component } from 'react'
import { TextField } from '@material-ui/core'
import { Field, Form, Store } from '../src'
import styles from './styles.icss'

//	Dodgy fix for react key complaint
const keyFix = value => `key${value}`

//	Our main component
class Formtest extends Component {

	constructor(props) {
		super(props)
		const me = this

		//	Set initial values of the store here
		this.store = new Store({
			list: ['a', 'b', 'c']
		},
		() => {
			/* eslint-disable no-underscore-dangle */
			if (me._isMounted) {
				me.forceUpdate()
			}
		})

		this.addItem = this.addItem.bind(this)
		this.bindRemoveItem = this.bindRemoveItem.bind(this)
	}

	componentDidMount() {
		/* eslint-disable no-underscore-dangle */
		this._isMounted = true
	}

	componentWillUnmount() {
		this._isMounted = false
	}

	addItem() {
		const list = this.store.get('list')
		list.push(' ')
		this.store.set('list', list)
	}

	bindRemoveItem(idx) {
		const me = this
		return () => {
			const list = me.store.get('list')
			list.splice(idx, 1)
			me.store.set('list', list)
		}
	}

	render() {
		return (
			<div className="route route__signup">
				<h1>Form with arbitrary list</h1>

				<div className={styles.data}>
					<h2>Data model</h2>
					<pre>{JSON.stringify(this.store.get(), null, 4)}</pre>
				</div>

				<p>
					This form contains a list of strings, it can be of an arbitrary length.
				</p>

				<Form store={this.store}>

					{/* A list of fields - we use ArrayIndex to indicate where in the array the item is */}
					<div>
						{this.store.get('list') && this.store.get('list').length > 0 &&
							this.store.get('list').map((item, idx) => (<div key={keyFix(idx)}>
								<Field
									name="list"
									arrayIndex={idx}
									placeholder="List item"
									component={TextField}
								/>
								<button type="button" onClick={this.bindRemoveItem(idx)}>X</button>
							</div>))
						}
					</div>

				</Form>

				<button type="button" onClick={this.addItem}>Add item</button>

			</div>
		)
	}
}

export default Formtest
