import React, { Component } from 'react'
import { TextField } from '@material-ui/core'
import { Field, Form, Store } from '../src'
import styles from './styles.icss'

//	Our main component
class Formtest extends Component {

	constructor(props) {
		super(props)
		const me = this

		//	Optionally set initial values of the store here
		this.store = new Store({
			name: 'Bob'
		},
		() => {
			/* eslint-disable no-underscore-dangle */
			if (me._isMounted) {
				me.forceUpdate()
			}
		})

		this.setValues = this.setValues.bind(this)
	}

	componentDidMount() {
		/* eslint-disable no-underscore-dangle */
		this._isMounted = true
	}

	componentWillUnmount() {
		this._isMounted = false
	}

	setValues() {
		const values = {
			name: 'Bobby McBobFace',
			phone: '0457755577'
		}
		this.store.set(values)
	}

	render() {
		return (
			<div className="route route__signup">
				<h1>Form with store in Form element</h1>

				<div className={styles.data}>
					<h2>Data model</h2>
					<pre>{JSON.stringify(this.store.get(), null, 4)}</pre>
				</div>

				<button type="button" onClick={this.setValues}>Set values</button>

				<Form store={this.store} debug>

					<div>
						<Field
							name="name"
							placeholder="Name"
							component={TextField}
						/>
					</div>

					<div>
						<Field
							debug
							name="phone"
							placeholder="Phone number"
							component={TextField}
						/>
					</div>

				</Form>

			</div>
		)
	}
}

export default Formtest
